hookToWindow(top);

//get messages from the extension script
chrome.runtime.onMessage.addListener(
		  function(request, sender, sendResponse) {
			  var cmd = request[0];
			  var param = request[1];
			  if (cmd == "autofillLogin") {
				  BFolders.autofillLogin(param, top);  
			  } else if (cmd == "autofillGeneratedPassword") {
				  BFolders.autofillGeneratedPassword(param, top);  
			  }
		  });

function hookToWindow(win) {
	
	// TODO consider window.captureEvents
	
	try {
		win.addEventListener("keyup", function(event) {
			  if (event.keyCode == 113) {
				  var url = top.document.URL;
				  if (event.ctrlKey || event.shiftKey) {
					  chrome.runtime.sendMessage(["generatePasswordCmd", url]);
				  } else {
					  chrome.runtime.sendMessage(["loginCmd", url]);
				  }
			  }
		  }, 
		  true); // at capture phase for a better chance of handling the key
		
		if (win.document instanceof HTMLDocument) {
			for (var i = 0; i < win.document.forms.length; i++) {
				var form = win.document.forms[i];
				form.addEventListener("submit", function(event) {
					handleFormSubmit(event.target);
				});
			}
		}
	} catch (e) {
		// Chrome may throw SecurityError
	}
	
	// RECURSION !!!
	for (var i = 0; i < win.frames.length; i++) {
		var childWin = win.frames[i];
		hookToWindow(childWin);
	}
}


function handleFormSubmit(form) {
	var login = BFolders.captureLogin(form);
	if (login == null)
		return;
	
	// send to the background script cause this script context will be re-creaed because of the navigation
	chrome.runtime.sendMessage(["handleLoginCapturedCmd", login]);
}

