function click(e) {
	var id = e.currentTarget.id;

	if (id == "loginCmd") {
		handleLoginCommand();	
	} else if (id == "generatePasswordCmd") {
		handleGeneratePasswordCommand();
	} else {
		handleCloseCommand();
	}
	
}

function handleCloseCommand() {
	window.close();
}

function handleLoginCommand() {
	chrome.tabs.query({'active': true}, function(tabs) {
		var url = tabs[0].url;
		chrome.runtime.sendMessage(["loginCmd", url]);
		window.close();
	});
}

function handleGeneratePasswordCommand() {
	chrome.tabs.query({'active': true}, function(tabs) {
		var url = tabs[0].url;
		chrome.runtime.sendMessage(["generatePasswordCmd", url]);
		window.close();
	});
}

document.addEventListener('DOMContentLoaded', function () {
	// change the hotkey text on Macs
	chrome.runtime.getPlatformInfo(function(platformInfo){
		if (platformInfo.os == "mac") {
			document.getElementById("generatePasswordHotkey").firstChild.nodeValue = "Shift+F2";
		}
	});
	
	var elms = document.querySelectorAll('tr');
	for (var i = 0; i < elms.length; i++) {
		elms[i].addEventListener('click', click);
	}
});